using System;

namespace ActionExamples
{
    public class ActionsNoParameters
    {
        public static void Runner()
        {
            // Printer(..) takes an Action with no parameters 

            Console.WriteLine("Running the actions with no parameters");

            Printer(PrinterMethod);
            Printer(() => PrinterMethod());

            Action printerActionAsLambda = () => Console.WriteLine("Explicitly defined printer action");
            Printer(printerActionAsLambda);

            Action printerActionAsMethod = PrinterMethod;
            Printer(printerActionAsMethod);

            Printer(() => Console.WriteLine("Hello from Console.WriteLine"));

            Console.WriteLine();
        }

        public static void Printer(Action myPrinterAction)
        {
            myPrinterAction();
        }

        public static void PrinterMethod()
        {
            Console.WriteLine("Hello from PrinterMethod");
        }
    }
}